// 002 u_xsd_viewer
// 17 sep 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_xsd_viewer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    exit_: TButton;
    clear_: TButton;
    Panel4: TPanel;
    PageControl1: TPageControl;
    display_: TTabSheet;
    initial_: TTabSheet;
    Memo1: TMemo;
    Panel5: TPanel;
    load_: TButton;
    save_edit_: TEdit;
    save_: TButton;
    initial_memo_: TMemo;
    prefix_edit_: TEdit;
    extension_edit_: TEdit;
    tree_: TTabSheet;
    xml_tree_: TTreeView;
    trace_: TCheckBox;
    xsd_: TTabSheet;
    Panel6: TPanel;
    load_xsd_: TButton;
    xsd_edit_: TEdit;
    save_xsd_: TButton;
    xsd_prefix_: TEdit;
    xsd_extension_: TEdit;
    xsd_memo_: TMemo;
    save_result_: TButton;
    iebnf: TTabSheet;
    iebnf_memo_: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure one_file_Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure load_Click(Sender: TObject);
    procedure save_Click(Sender: TObject);
    procedure save_result_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_c_ini_file
      , u_strings

      , u_c_xsd_viewer
      ;

    {$R *.DFM}

    
    const k_initial_directory= 'c:\prog\web\utils\downloader\';
            k_extension= '.pas';
            k_file_name= 'pascal.pas';

          k_xxx_path_ini_key=   'ini_xxx_path';

          k_xxx_path=   'c:\prog\xxx\';

    var g_path: String= k_xxx_path;
        g_file_name: String= k_file_name;
        g_c_ini_file: c_ini_file= Nil;
        g_file_count: Integer= 0;

        g_c_result_list: tStringList;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      var l_c_iebnf: tStringList;  
      begin
        g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;
        Form1.load_Click(Nil);

        Inc(g_file_count);
        display('  '+ p_file_name);

        with c_xsd_viewer.create_xsd_viewer('xsd_viewer') do
        begin
          build_xml_text(p_path, p_file_name);

          stop_display;
          display_line;
          display('refs');
          find_refs;

          display_line;
          display('types');
          find_types;
          start_display;

          g_c_result_list:= tStringList.Create;
          display_forward_recursive(0, 'BAS ', m_c_xml_text.m_c_xml_content, g_c_result_list);

          Form1.xml_tree_.Items.Clear;
          // build_treeview(Form1.xml_tree_);
          build_small_treeview(Form1.xml_tree_);

          l_c_iebnf:= tStringList.Create;
          build_iebnf(l_c_iebnf);
          Form1.iebnf_memo_.Lines.Assign(l_c_iebnf);
        end; // with c_xsd_viewer

        Form1.xsd_memo_.Lines.Assign(g_c_result_list);
      end; // my_call_back

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_xxx_path);
        end; // with g_c_ini_file

        set_directory_listbox_directory(DirectoryListBox1, g_path);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    // -- call handler

    procedure TForm1.one_file_Click(Sender: TObject);
        // -- one static file
      begin
        display('file_name '+ k_file_name);
        g_file_count:= 0;
        my_call_back(0, k_initial_directory, k_file_name, Nil);
      end; // btn_one_fileClick

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      var l_path, l_name: String;
      begin
        l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          l_name:= Items[ItemIndex];

        g_file_count:= 0;
        my_call_back(0, l_path+ '\', l_name, Nil);
      end; // FileListBox1Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    procedure TForm1.load_Click(Sender: TObject);
      begin
        initial_memo_.Lines.LoadFromFile(g_path+ g_file_name);
        save_edit_.Text:= ChangeFileExt(g_file_name, '');
        xsd_edit_.Text:= ChangeFileExt(g_file_name, '');
        extension_edit_.Text:= ExtractFileExt(g_file_name);
      end; // load_Click

    procedure TForm1.save_Click(Sender: TObject);
      begin
       xsd_memo_.Lines.SaveToFile(g_path+ '_pas\'
         + xsd_prefix_.Text+ xsd_edit_.Text+ xsd_extension_.Text);
      end; // save_Click

    procedure TForm1.save_result_Click(Sender: TObject);
      begin
        if g_c_result_list<> Nil
          then g_c_result_list.SaveToFile(g_path+ 'result_xsd.pas');
      end; // save_result_Click


end.


